
#include <iostream.h>
#include <math.h>

float min(float x, float y) {
  return x <= y ? x : y ;
}

class Point {
  float x ;
  float y ;
  friend float angle(Point, Point, Point) ;
public :
  void print() {
    cout << x << ", " << y ;
  }
  Point(float X, float Y) : x(X), y(Y) {}
} ;
 
float angle(Point P, Point Q, Point R) {

  // Actually cosine of angle

  float ux, uy, vx, vy ;

  ux = P.x - Q.x ;
  uy = P.y - Q.y ;
  vx = R.x - Q.x ;
  vy = R.y - Q.y ;

  return (ux * vx + uy * vy) / sqrt((ux * ux + uy * uy) * (vx * vx + vy * vy)) ;
}

class Triangle {
  Point P ;
  Point Q ;
  Point R ;
public :
  void print() {
    cout << angle(R, P, Q) << ", " << angle(P, Q, R) << ", " << angle(Q, R, P) ;
  }
  void print(float&) ;
  Triangle(Point& p, Point& q, Point& r) : P(p), Q(q), R(r) {}
} ;
 
void Triangle :: print(float& minAngle) {
  float RPQ = angle(R, P, Q) ;
  float PQR = angle(P, Q, R) ;
  float QRP = angle(Q, R, P) ;

  cout << RPQ << ", " << PQR << ", " << QRP ;

  minAngle = min(RPQ, min(PQR, QRP)) ;
}

void printTriangles(float x, float y, float z, float t,
                    float u, float v, float w) {
  Point A(0.0, 0.0) ;
  Point B(1.0, 0.0) ;
  Point C(1.0, 1.0) ;
  Point D(0.0, 1.0) ;
  Point E(x  , 0.0) ;
  Point F(0.0, y  ) ;
  Point G(z  , t  ) ;
  Point H(u  , v  ) ;
  Point I(w  , (1 - w) * t / (1 - z)) ;

  Triangle AEH(A, E, H) ;
  Triangle EBI(E, B, I) ;
  Triangle EIH(E, I, H) ;
  Triangle AHF(A, H, F) ;
  Triangle HGF(H, G, F) ;
  Triangle HIG(H, I, G) ;
  Triangle BCG(B, C, G) ;
  Triangle FGD(F, G, D) ;
  Triangle GCD(G, C, D) ;

  float minAngles [9] ;
  float minAngle = 1.0 ; 

  cout << "AEH: " ; AEH.print(minAngles [0]) ; cout << "\n" ;
  cout << "EBI: " ; EBI.print(minAngles [1]) ; cout << "\n" ;
  cout << "EIH: " ; EIH.print(minAngles [2]) ; cout << "\n" ;
  cout << "AHF: " ; AHF.print(minAngles [3]) ; cout << "\n" ;
  cout << "HGF: " ; HGF.print(minAngles [4]) ; cout << "\n" ;
  cout << "HIG: " ; HIG.print(minAngles [5]) ; cout << "\n" ;
  cout << "BCG: " ; BCG.print(minAngles [6]) ; cout << "\n" ;
  cout << "FGD: " ; FGD.print(minAngles [7]) ; cout << "\n" ;
  cout << "GCD: " ; GCD.print(minAngles [8]) ; cout << "\n" ;

  for(int i = 0 ; i < 9 ; i++)
    minAngle = min(minAngle, minAngles [i]) ;
  cout << "minimum cosine = " << minAngle << "\n" ;

  cout << "A: " ; A.print() ; cout << "\n" ;
  cout << "B: " ; B.print() ; cout << "\n" ;
  cout << "C: " ; C.print() ; cout << "\n" ;
  cout << "D: " ; D.print() ; cout << "\n" ;
  cout << "E: " ; E.print() ; cout << "\n" ;
  cout << "F: " ; F.print() ; cout << "\n" ;
  cout << "G: " ; G.print() ; cout << "\n" ;
  cout << "H: " ; H.print() ; cout << "\n" ;
  cout << "I: " ; I.print() ; cout << "\n" ;
}

main () {
  float x, y, z, t, u, v, w ;

  cout << "x?: " ;
  cin >> x ;
  cout << "y?: " ;
  cin >> y ;
  cout << "z?: " ;
  cin >> z ;
  cout << "t?: " ;
  cin >> t ;
  cout << "u?: " ;
  cin >> u ;
  cout << "v?: " ;
  cin >> v ;
  cout << "w?: " ;
  cin >> w ;

  printTriangles(x, y, z, t, u, v, w) ;
}
